"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const query_string_1 = require("query-string");
// if passed a location, will mutate it so we can see what changes are being made
function makeMockHistory(location = {}) {
    return {
        replace: jest
            .fn()
            .mockImplementation(newLocation => Object.assign(location, newLocation)),
        push: jest
            .fn()
            .mockImplementation(newLocation => Object.assign(location, newLocation)),
    };
}
exports.makeMockHistory = makeMockHistory;
// helper to get the query params from the updated location
function calledReplaceQuery(history, index = 0) {
    return query_string_1.parse(history.replace.mock.calls[index][0].search);
}
exports.calledReplaceQuery = calledReplaceQuery;
// helper to get the query params from the updated location
function calledPushQuery(history, index = 0) {
    return query_string_1.parse(history.push.mock.calls[index][0].search);
}
exports.calledPushQuery = calledPushQuery;
function makeMockLocation(query) {
    const queryStr = query_string_1.stringify(query);
    return {
        protocol: 'http:',
        host: 'localhost',
        pathname: '/',
        search: queryStr.length ? `?${queryStr}` : '',
    };
}
exports.makeMockLocation = makeMockLocation;
