"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
describe('params', () => {
    describe('smoke tests', () => {
        it('StringParam', () => {
            expect(index_1.StringParam.encode('foo')).toBe('foo');
            expect(index_1.StringParam.decode('bar')).toBe('bar');
        });
        it('NumberParam', () => {
            expect(index_1.NumberParam.encode(123)).toBe('123');
            expect(index_1.NumberParam.decode('345.2')).toBe(345.2);
        });
        it('ObjectParam', () => {
            expect(index_1.ObjectParam.encode({ foo: 'bar' })).toBe('foo-bar');
            expect(index_1.ObjectParam.decode('foo-bar')).toEqual({ foo: 'bar' });
        });
        it('ArrayParam', () => {
            expect(index_1.ArrayParam.encode(['foo', 'bar'])).toBe('foo_bar');
            expect(index_1.ArrayParam.decode('foo_bar')).toEqual(['foo', 'bar']);
        });
        it('JsonParam', () => {
            expect(index_1.JsonParam.encode({ foo: 'bar' })).toBe('{"foo":"bar"}');
            expect(index_1.JsonParam.decode('{"foo":"bar"}')).toEqual({ foo: 'bar' });
        });
        it('DateParam', () => {
            expect(index_1.DateParam.encode(new Date(2019, 2, 14))).toBe('2019-03-14');
            const result = index_1.DateParam.decode('2019-03-14');
            expect(result.getFullYear()).toBe(2019);
            expect(result.getMonth()).toBe(2);
            expect(result.getDate()).toBe(14);
        });
        it('BooleanParam', () => {
            expect(index_1.BooleanParam.encode(true)).toBe('1');
            expect(index_1.BooleanParam.decode('0')).toBe(false);
        });
        it('NumericObjectParam', () => {
            expect(index_1.NumericObjectParam.encode({ foo: 123 })).toBe('foo-123');
            expect(index_1.NumericObjectParam.decode('foo-123')).toEqual({ foo: 123 });
        });
        it('NumericArrayParam', () => {
            expect(index_1.NumericArrayParam.encode([1, 2])).toBe('1_2');
            expect(index_1.NumericArrayParam.decode('1_2')).toEqual([1, 2]);
        });
    });
});
